
// **********************************************************************//
// TABLERO CERVECERO V4 SOLO CON 4 SONDAS -HR202- PUERTO SERIE y NEXTION //
// **********************************************************************//
#include <SoftwareSerial.h>
#include <doxygen.h>
#include <NexButton.h>
#include "Nextion.h"
#include <OneWire.h>
#include<Wire.h>
#include <DallasTemperature.h>
#define ONE_WIRE_BUS_PIN 3
#define nexSerial Serial2 // probar si funciona.- Ojo fuente: http://support.iteadstudio.com/support/discussions/topics/1000065090
OneWire oneWire(ONE_WIRE_BUS_PIN);
DallasTemperature sensors(&oneWire);
const int led = 9;


SoftwareSerial nextion(16, 17);
//Nextion myNextion(nextion 9600);

// *********************************************************

// SONDAS ADDRESSES //
DeviceAddress S1 = { 0x28, 0xFF, 0xD5, 0x38, 0xA0, 0x16, 0x04, 0x41 }; //
DeviceAddress S2 = { 0x28, 0xFF, 0x30, 0x90, 0x24, 0x17, 0x03, 0x47 }; //
DeviceAddress S3 = { 0x28, 0xFF, 0x73, 0xA7, 0x01, 0x17, 0x04, 0x0C }; //
DeviceAddress S4 = { 0x28, 0xFF, 0x0F, 0x8E, 0x01, 0x17, 0x03, 0x20 };

// ------------------------



//Declara los objetos a utilizar [pagina id:0,componente id:1, NombreComponente: "Objeto_ObjName"] 
NexDSButton ObjDualBoton = NexDSButton(0, 1, "ONOFFBOMBA");
NexDSButton ObjDualBoton1 = NexDSButton(0, 12, "B1");
NexText ObjTxtEstado =  NexText(0, 12, "B1");

// Registro al objeto Dual State Button a la lista de eventosTouch
NexTouch *nex_listen_list[] = 
{
    &ObjDualBoton,
    NULL
};


NexNumber MACERADO = NexNumber(0, 7, "n0"); // Funcion para mostrar temperatura en pantalla numericamente//
NexNumber COCCION = NexNumber(0, 8, "n1");
NexNumber LAVADO = NexNumber(0, 9, "n2");
NexNumber MUESTREO = NexNumber(0, 20, "n3");
NexNumber HUMEDAD = NexNumber(0, 23, "n4");
NexWaveform s0 = NexWaveform(0, 18, "s0");   //Graficara curva de Macerado (ver de reducir la velocidad)
//NexText prueba  =  NexText(0, 25, "t13");  // solo para test


// Creo que una funcion que ingresara cuando el evento Touch sea detectado
void LlamadoFuncionDualBoton(void *ptr);

//***********************VOID SETUP **************************//
void setup()   /****** SETUP: RUNS ONCE ******/
{
//myNextion.init();  
nexInit();
init();

//Inicio la comunicacion entre el Arduino y la Pantalla


 
  
  /*defino el pin 9 definido como led como salida*/
  pinMode(led, OUTPUT);  // Control del contactor

  //inicio en estado apagado
  // digitalWrite(led, LOW); 
  
  Serial.begin(9600);
   sensors.begin();
  nexSerial.begin(9600); // Nextion terminal probar si funciona.- Ojo fuente: http://support.iteadstudio.com/support/discussions/topics/1000065090
   
  // set the resolution to 10 bit (Can be 9 to 12 bits .. lower is faster)
  sensors.setResolution(S1, 9);
  sensors.setResolution(S2, 9);
  sensors.setResolution(S3, 9);
  sensors.setResolution(S4, 9);

  
   
}//--(end setup )---


// ***************** VOID LOOP  *************************//

void loop()  

{
  delay(1500);
  
  //**************************************

 ObjDualBoton.attachPop(LlamadoFuncionDualBoton, &ObjDualBoton);
    ObjDualBoton1.attachPop(LlamadoFuncionDualBoton, &ObjDualBoton1);
   nexLoop(nex_listen_list);

  
   //********* SERIALES PARA LAS SONDAS************
  
 delay(1500);
 
   Serial.print("Initializing Temperature Control Library Version ");
  Serial.println(DALLASTEMPLIBVERSION);
  Serial.print("Number of Devices found on bus= ");  
  Serial.println(sensors.getDeviceCount());   
  Serial.print("Getting temperatures... ");   
  // Command all devices on bus to read temperature  
  
  sensors.requestTemperatures();  
  

//---- MACERACION------------------
     Serial.println(); 
     Serial.print("MACERACION=");
     printTemperature(S1);        
     Serial.println();    
//---- COCCION--------------------
     Serial.print("COCCION=");
      printTemperature(S2);
      Serial.println();   
//---- ENFRIADO //--- LA sonda del -127.00  Error en sonda.- 
     Serial.print("ENFRIADO=");
     printTemperature(S3);
     Serial.println(); 
//---- MUESTREO //--- LA sonda del -127.00  Error en sonda.-
     Serial.print("MUESTREO=");
     printTemperature(S4);
     Serial.println(); 
//------HUMEDAD  //---------------
  //-----  HUMEDAD HR202 - - - read the input on analog pin 0: A0= HR202
  Serial.print("HUMEDAD=");
  int sensorValue = analogRead(A0);
  Serial.println(sensorValue/10);

//----------FIN DE IMPRESION SERIAL-------------------------------------------//

  
  //*Mostrar el Valor de DS18B20*//
   //mySerial.print(S1);
   MACERADO.setValue(S1);   // MACERADO
   COCCION.setValue(S2);    // COCCION
   LAVADO.setValue(S3);     // LAVADO
   MUESTREO.setValue(S4);   // MUESTREO
   HUMEDAD.setValue(A0);    // HUMEDAD
   s0.addValue(0,S1);       // CURVA DE MACERADO
  delay(1500); 
}//--(end main loop )---


// ******************VOID TEMP****************************
   void printTemperature(DeviceAddress deviceAddress)


{

float  tempC = sensors.getTempC(deviceAddress); 
     if (tempC == -127.00) // ojo
   {
   Serial.print("Error getting temperature  ");
   } 
  else  // ojo
   {
   //Serial.print("C: ");
 Serial.print(tempC);   //ojo
    }
    //temperature = sensors.getTempCByIndex(0);  // test  http://support.iteadstudio.com/support/discussions/topics/11000010580
    // Txt_Temp.setValue((int)temperature);      //test  
    //
    sensors.requestTemperatures();  // <== Put it here

    }

//******************************** VOID DUAL BOTON*********
void LlamadoFuncionDualBoton(void *ptr)
{
  delay(1500);
  
    uint32_t Estado_dual;
    /* Consigo el valor del estado del componente. */
    ObjDualBoton.getValue(&Estado_dual);
    
    if(Estado_dual) 
    {
       ObjTxtEstado.setText("ON"); digitalWrite(led, HIGH);
    }
    else
    {
       ObjTxtEstado.setText("OFF"); digitalWrite(led, LOW);
    }
 delay(1000);
}
 

// End printTemperature

//*********( THE END )***********




